;
; LOD Player V1.00
; Coded by Csabo of LOD 2000-2003
;
F1LO	= $FF0E
F1HI	= $FF12
F2LO	= $FF0F
F2HI	= $FF10
VOL	= $FF11

; Address of freq table
; change it to whatever suits you
; the table will take up $80 bytes
freqs = $0380

; Constants
END_MARK	= $FF
SNARE		= $FE  
QUIET		= $FD
LOOP_START	= $FC
LOOPS		= $FC
LOOP_END	= $FB
LOOPE		= $FB
SET_VOL		= $F0
ns		= $80	; (N)o (S)peed

; Word Variables
PCH1		= $60	; channel data pattern pointers
PCH2		= $62

CH1		= $64	; channel data pointers
CH2		= $66

LOOP_CH1	= $68
LOOP_COUNT1	= $6A

LOOP_CH2	= $6C
LOOP_COUNT2	= $6E

; Byte Variables
CWAIT1		= $70	; wait counters
CWAIT2		= $71
PWAIT1		= $72	; (P)revious wait counters
PWAIT2		= $73

CHANNELS	= $74
VOLUME		= $75
DECFLAG		= $76

;-----
;Note contstants for music

C0 = 0
Ci = 1
D0 = 2
Di = 3
E0 = 4
F0 = 5
Fi = 6
G0 = 7
Gi = 8
A0 = 9
Ai = 10
B0 = 11

O2 = -9
O3 = 3
O4 = 15
O5 = 27
O6 = 39
O7 = 51

PLAYER_INIT
	jsr reset_ch1
	jsr reset_ch2
	;
PLAYER_INIT_POS			; use this entry point
				; if you manually reset
				; music position
	jsr advance_ch1
	jsr advance_ch2
	;
	ldx #$01
	stx CWAIT1
	stx CWAIT2
	;
	dex
	ldy #$00
	sty freqs
	sty freqs+1
freq_init
	lda freqs,x
	clc
	adc freqs_add,y
	sta freqs+2,x
	inx
	lda freqs,x
	adc #$00
	sta freqs+2,x
	inx
	iny
	cpy #63
	bne freq_init
	;
	lda #$30
	sta CHANNELS
	lda #$07
	sta VOLUME
	;
	rts

advance_ch1
	ldy #$01
	lda (PCH1),y
	beq res_1		; 00 in channel means end of pattern list
	sta CH1 + 1
	dey
	lda (PCH1),y
	sta CH1
	;
	lda PCH1
	clc
	adc #$02
	sta PCH1
	bcc *+4
	inc PCH1+1
	;
	rts
res_1	jsr reset_ch1
	jmp advance_ch1	

reset_ch1
	ldx #channel1 & 255
	ldy #channel1 >> 8
reset_ch1_pos
	stx PCH1
	sty PCH1 + 1
	rts

advance_ch2
	ldy #$01
	lda (PCH2),y		
	beq res_2		; 00 - end of pattern list
	sta CH2 + 1
	dey
	lda (PCH2),y
	sta CH2
	;
	lda PCH2
	clc
	adc #$02
	sta PCH2
	bcc *+4
	inc PCH2+1
	;
	rts
res_2	jsr reset_ch2
	jmp advance_ch2

reset_ch2
	ldx #channel2 & 255
	ldy #channel2 >> 8
reset_ch2_pos
	stx PCH2
	sty PCH2 + 1
	rts

adv_1	sty padd1 + 1
	;
	lda CH1
	clc
padd1	adc #$00
	sta CH1
	bcc noi_1
	inc CH1 + 1
noi_1	rts

adv_2	sty padd2 + 1
	;
	lda CH2
	clc
padd2	adc #$00
	sta CH2
	bcc noi_2
	inc CH2 + 1
noi_2	rts

PLAYER
	;------------------
	dec CWAIT1		; new note yet?
	beq get_note1
	jmp get_note21		; nope, skip to channel 2
	;
get_note1
	ldy #$00
	lda (CH1),y		; get note
	cmp #$F0		; special byte?
	bcc sound1		; no, jump to sound play
	;
	cmp #LOOP_START		; loop start?
	beq loop_start_1
	;
	cmp #LOOP_END
	beq loop_end_1
	;
	cmp #QUIET
	beq quiet_1
	;
	cmp #END_MARK
	bne set_vol_1
	;
	jsr advance_ch1
	jmp get_note1
	;
set_vol_1
	and #$0F
disable_set_vol			; PUT "$A9" here to disable
	sta VOLUME
	jmp end_of_loop_1
	;
quiet_1
	lda CHANNELS
	and #$20
	sta CHANNELS
	jmp get_speed_1
	;
loop_end_1
	dec LOOP_COUNT1
	beq end_of_loop_1
	;
	lda LOOP_CH1		; jump back!
	sta CH1
	lda LOOP_CH1 + 1
	sta CH1 + 1
	;
	jmp get_note1
	;
end_of_loop_1
	iny
	jsr adv_1
	jmp get_note1
	;
	;-----
loop_start_1
	iny
	lda (CH1),y		; get next byte loop counter value
	sta LOOP_COUNT1		; store it
	iny
	jsr adv_1
	;
	lda CH1			; store loop position!
	sta LOOP_CH1
	lda CH1 + 1
	sta LOOP_CH1 + 1
	;
	jmp get_note1
	;
sound1
	and #$7F		; clear highest bit
	asl a			; * 2
	tax
	lda freqs,x		; get freq low byte
	sta F1LO
	inx			; and high byte
	lda F1HI		; keep bits 2-7
	and #$FC
	ora freqs,x
	sta F1HI		; for char. map
	;
	;-------
	lda CHANNELS
	ora #$10
	sta CHANNELS
	;-------
	;
	lda (CH1),y		; get note again
	cmp #ns
	bcc get_speed_1
	;
	lda PWAIT1
	bne store_speed_1
	;
get_speed_1
	iny
	lda (CH1),y
store_speed_1
	iny
	sta CWAIT1
	sta PWAIT1
	;------------
	jsr adv_1
	;------------------------------------------------------------------
	;
get_note21
	dec CWAIT2		; new note yet on channel2?
	beq get_note2
	jmp pend_1		; nope, go to player end
	;
get_note2
	ldy #$00
	lda (CH2),y
	cmp #$F0
	bcc sound2
	;
	cmp #SNARE
	beq play_snare
	;
	cmp #QUIET
	beq quiet_2
	;
	cmp #LOOP_START
	beq loop_start_2
	;
	cmp #END_MARK
	bne loop_end_2
	;
	; --- assume end mark
	;
	jsr advance_ch2
	jmp get_note2
	;          
quiet_2
	lda CHANNELS
	and #$10
	sta CHANNELS
	jmp get_speed_2
	;
loop_end_2
	dec LOOP_COUNT2
	beq end_of_loop_2
	;
	lda LOOP_CH2		; jump back!
	sta CH2
	lda LOOP_CH2 + 1
	sta CH2 + 1
	;
	jmp get_note2
	;
end_of_loop_2
	iny
	jsr adv_2
	jmp get_note2
	;
	;-----
loop_start_2
	iny
	lda (CH2),y
	sta LOOP_COUNT2
	iny
	jsr adv_2
	;
	lda CH2			; store loop position!
	sta LOOP_CH2
	lda CH2 + 1
	sta LOOP_CH2 + 1
	;
	jmp get_note2
	;
play_snare
	sta F2LO	; = $fe
	lda #$03
	sta F2HI	; Snare Drum starting Freq ($03FE)
	;
	lda #$10
	sta DECFLAG	; Dec freq by $20 every cycle
	;
	lda CHANNELS
	and #$DF
	ora #$40
	sta CHANNELS	; turn VOICE2 to noise
	;
	jmp ch_2
	;
sound2
	and #$7F
	asl a
	tax
	lda freqs,x
	sta F2LO
	inx
	lda freqs,x
	sta F2HI
	;
	lda #$00
	sta DECFLAG
	;
	lda CHANNELS
	and #$BF
	ora #$20
	sta CHANNELS	; turn VOICE2 to sound
	;
	;
	lda (CH2),y
	cmp #ns
	bcc get_speed_2
	;
	lda PWAIT2
	bne store_speed_2
	;
get_speed_2
	;
ch_2	;
	iny
	lda (CH2),y
store_speed_2
	iny
	sta CWAIT2
	sta PWAIT2
	;
	jsr adv_2
	;
pend_1
	lda DECFLAG
	beq pend_2
	;
	lda F2LO
	sec
	sbc DECFLAG
	sta F2LO
	lda F2HI
	sbc #$00
	sta F2HI
	;
pend_2
	lda CHANNELS
	ora VOLUME
	sta VOL
	;
	rts

freqs_add
	if NON_PAL
	db  6, 57, 54, 51, 48, 45, 43, 40
	db 38, 36, 34, 32, 31, 28, 27, 25
	db 24, 23, 21, 21, 19, 18, 17, 16
	db 15, 14, 14, 12, 12, 12, 10, 10
	db 10,  9,  8,  8,  8,  7,  7,  6
	db  6,  6,  5,  5,  5,  4,  5,  4
	db  3,  4,  3,  4,  3,  2,  3,  3
	db  2,  2,  2,  2,  2,  2,  2
	else
	db 15, 57, 53, 51, 47, 45, 43, 39
	db 38, 36, 33, 32, 30, 28, 27, 26
	db 23, 23, 21, 20, 18, 18, 17, 16
	db 15, 14, 14, 12, 12, 11, 11, 10
	db  9,  9,  9,  8,  7,  7,  7,  6
	db  6,  6,  5,  5,  5,  4,  4,  4
	db  4,  4,  3,  3,  3,  3,  2,  3
	db  2,  3,  2,  2,  2,  1,  2  
	endif
